;(function($){
    var args;
    $.swiperInit = ({
        init:function(options){ //组件初始化
            init(options);
        },
    });
    $.swiperInit.defaults = {
        "hideExpInit" : false, //释义折叠初始化开关
    };
    //初始化
    function init(options){
        args = $.extend({}, $.swiperInit.defaults, options);
        swiperInit();
        if(args.hideExpInit) swiperHideExpInit();
    }
    
    //滑动组件初始化
    function swiperInit(){
        var startPos, startTran, isTouching;
        var goline = 100;
        var goPrev = $('.goPrev'), goNext = $('.goNext');
        pubArgu.swiperMain = new Swiper('#swiperMain', {
            direction: 'vertical',
            slidesPerView: 'auto',
            freeMode: true,
            onInit: function(s){
                var slide = s.slides[0];
                var conHei = $(slide).children().height();
                if(slide.offsetHeight != conHei){
                    $(slide).css('height', conHei);
                    s.onResize();
                }
                var btmLine = conHei * -1 + pubArgu.windowHeight;
                s.params.btmLine = btmLine < 0 ? btmLine : 0;
                if($('#main-scrollbar').length){
                    s.params.scrollbar = '#main-scrollbar';
                    s.onResize();
                }
            },
            onTouchStart: function(s){
                goPrev.removeClass('ani');
                goNext.removeClass('ani');
                isTouching = 1;
                s.setWrapperTransition(0);
                s.setWrapperTranslate(s.getWrapperTranslate());
                s.offsetTranslate = 0; //滑动过程中改变内容高度，对滑动位置进行偏移
                s.params.disOffset = 0; //处理非锁定swiper的位置偏移
                s.params.blOffset = 0; //滑动过程中重置swiper尺寸，对 btmLine 的 变更补偿
                s.params.lockTransitionEnd = 0; //锁定默认的惯性滚动操作
            },
            onSetTranslate: function(s,val){
                if(isTouching && !pubArgu.goWordLock){
                    if(s.isBeginning){
                        if(val > goline){
                            goPrev.css({"-webkit-transform": "translateY("+(val-30)/3+"px)"});
                            goPrev.addClass('rot');
                        }
                        else if(val > 30){
                            var opa = Math.floor(Math.min(val-30, 100))/100;
                            goPrev.css({"opacity": opa, "-webkit-transform": "translateY("+(val-30)/3+"px)"});
                            goPrev.removeClass('rot');
                        }
                    }
                    if(s.isEnd){
                        var bl = s.params.btmLine;
                        var tran = (val - bl + 30)/3;
                        if(val < bl - goline){
                            goNext.css({"-webkit-transform": "translateY("+tran+"px)"});
                            goNext.addClass('rot');
                        }
                        else if(val < bl - 30){
                            var opa = Math.floor(Math.min(-(val - bl + 30), 100))/100;
                            goNext.css({"opacity": opa, "-webkit-transform": "translateY("+tran+"px)"});
                            goNext.removeClass('rot');
                        }
                    }
                    else if(!s.isBeginning){
                        goPrev.attr('style',null);
                        goNext.attr('style',null);
                    }
                }
            },
            onTouchEnd: function(s){
                isTouching = 0;
                goPrev.addClass('ani').removeClass('rot');
                goPrev.attr('style',null);
                goNext.addClass('ani').removeClass('rot');
                goNext.attr('style',null);
                
                if(s.translate > goline && !pubArgu.goWordLock){
                    goPrevWord();
                }
                else if(s.translate < s.params.btmLine - goline && !pubArgu.goWordLock){
                    goNextWord();
                }
                else if(s.translate > 0){
                    s.setWrapperTransition(200);
                    s.setWrapperTranslate(0);
                }
                else if(s.translate < s.params.btmLine){
                    s.setWrapperTransition(200);
                    s.setWrapperTranslate(s.params.btmLine);
                }
            }
        });

        pubArgu.tagBar = new Swiper('#tagBar', {
            slidesPerView : 3,
            onInit: function(s){
                if(s.slides.length < 3){
                    s.params.slidesPerView = 2;
                    s.onResize();
                }
            },
            onTap: function(s){
                pubArgu.swiperBody.slideTo(s.clickedIndex);
            }
        });
        var bodySwipering;
        pubArgu.swiperBody = new Swiper('#swiperBody', {
            touchRatio : 0.7,
            onSliderMove: function(){
                bodySwipering = 1;
            },
            onSlideChangeStart: function(){
                bodySwipering = 1;
                updateNavPosition();
            },
            onSlideChangeEnd: function(){
                bodySwipering = 0;
            },
            onTouchEnd: function(){
                bodySwipering = 0;
            },
        });
        var firstSkip = 0, firstStep, mfirstStep;
        $('.swiperPages').each(function(){
            var sp = new Swiper(this, {
                scrollbar: $(this).find('.swiper-scrollbar'),
                direction: 'vertical',
                slidesPerView: 'auto',
                freeMode: true,
                lock: 0,
                onInit: function(s){
                    var slide = s.slides[0];
                    var conHei = $(slide).children().height();
                    if(slide.offsetHeight != conHei){
                        $(slide).css('height', conHei);
                        s.onResize();
                        s.update();
                    }
                    var btmLine = conHei * -1 + s.height;
                    s.params.btmLine = btmLine < 0 ? btmLine : 0;
                },
                onTouchStart: function(s){
                    startPos = s.translate;
                    startTran = pubArgu.swiperMain.translate;
                    firstSkip = 0;
                    s.setWrapperTransition(0);
                    s.setWrapperTranslate(s.getWrapperTranslate());
                    s.offsetTranslate = 0; //滑动过程中改变内容高度，对滑动位置进行偏移
                    s.params.blOffset = 0; //滑动过程中重置swiper尺寸，对 btmLine 的 变更补偿
                    s.params.lockTransitionEnd = 0; //锁定默认的惯性滚动操作
                },
                onTouchMove: function(swiper){
                    // console.log(bodySwipering)
                    var headHeight = pubArgu.headHeight, swiperMain = pubArgu.swiperMain;
                    if(!bodySwipering){
                        var diff = swiper.touches.diff;
                        var pos = startPos + diff; //滑动到的预期位置
                        if(startTran <= 0 && startTran > headHeight){ //开始滑动时的位置，处于swiperMain的头部高度范围内
                            var mainPos = startTran + diff;
                            if(firstSkip){
                                if(mainPos < 0 && mainPos > headHeight){
                                    var dis = mainPos;
                                    swiperMain.setWrapperTransition(0);
                                    swiperMain.setWrapperTranslate(dis);
                                }
                                else if(mainPos <= headHeight){
                                    swiperMain.setWrapperTranslate(headHeight);
                                    if(!firstStep){
                                        firstStep = swiper.getK();
                                    }
                                    swiper.setWrapperTranslate(swiper.getK()-firstStep - swiper.offsetTranslate);
                                }
                                else if(mainPos >= 0){
                                    swiperMain.setWrapperTransition(0);
                                    if(!mfirstStep){
                                        mfirstStep = swiper.getK();
                                    }
                                    swiperMain.setWrapperTranslate(swiper.getK()-mfirstStep);
                                }
                            }
                            else {
                                firstSkip = 1;
                                if(mainPos >= 0 && !mfirstStep){
                                    mfirstStep = 0.1;
                                }
                            }
                        }
                        else {
                            if(firstSkip){
                                if(pos <= 0){
                                    var dis = pos;
                                    var bl = swiper.params.btmLine;
                                    swiperMain.setWrapperTranslate(headHeight);
                                    if(dis > bl - swiper.params.blOffset){
                                        swiper.setWrapperTranslate(dis - swiper.offsetTranslate);
                                    }
                                    else {
                                        dis = bl - swiper.params.blOffset + 1 - Math.pow(bl - swiper.params.blOffset - dis, swiper.params.resistanceRatio);
                                        swiper.setWrapperTranslate(dis - swiper.offsetTranslate);
                                    }
                                }
                                else if(pos > 0){
                                    swiper.setWrapperTranslate(0);
                                    swiperMain.setWrapperTransition(0);
                                    var dis = pos + headHeight;
                                    if(dis < 0 ){
                                        swiperMain.setWrapperTranslate(dis);
                                    }
                                    else {
                                        if(!firstStep){
                                            firstStep = swiper.getK();
                                        }
                                        swiperMain.setWrapperTranslate(swiper.getK()-firstStep);
                                    }
                                }
                            }
                            else {
                                firstSkip = 1;
                            }
                        }
                    }
                },
                onTouchEnd: function(swiper){
                    firstStep = 0;
                    mfirstStep = 0;
                    isTouching = 0;
                    var swiperMain = pubArgu.swiperMain;
                    if(swiperMain.translate > 0){
                        if(swiperMain.translate > goline && !pubArgu.goWordLock){
                            goPrevWord();
                        }
                        swiperMain.setWrapperTransition(200);
                        swiperMain.setWrapperTranslate(0);
                    }
                    setTimeout(function(){
                        if(swiper.translate < 0){
                            swiperMain.setWrapperTransition(200);
                            swiperMain.setWrapperTranslate(pubArgu.headHeight);
                        }
                        else if(swiper.translate > 50){
                            swiperMain.setWrapperTransition(200);
                            swiperMain.setWrapperTranslate(0);
                        }
                    },10);
                    var s = swiper;
                    if(s.translate < s.params.btmLine - goline && !pubArgu.goWordLock){
                        goNextWord();
                    }
                    else if(s.translate > 0){
                        s.setWrapperTransition(200);
                        s.setWrapperTranslate(0);
                    }
                    else if(s.translate < s.params.btmLine){
                        s.setWrapperTransition(200);
                        s.setWrapperTranslate(s.params.btmLine);
                    }
                },
                onSetTranslate: function(swiper,val){
                    if(isTouching && swiper.isEnd && !pubArgu.goWordLock){
                        var bl = swiper.params.btmLine;
                        var tran = (val - bl + 30)/3;
                        if(val < bl - goline){
                            goNext.css({"-webkit-transform": "translateY("+tran+"px)"});
                            goNext.addClass('rot');
                        }
                        else if(val < bl - 30){
                            var opa = Math.floor(Math.min(-(val - bl + 30), 100))/100;
                            goNext.css({"opacity": opa, "-webkit-transform": "translateY("+tran+"px)"});
                            goNext.removeClass('rot');
                        }
                        else {
                            goNext.attr('style',null);
                        }
                    }
                },
            });
            pubArgu.swiperPages.push(sp);
        });
    }

    //tagBar滑动切换
    function updateNavPosition(){
        $('#tagBar .active-nav').removeClass('active-nav');
        var activeNav = $('#tagBar .swiper-slide').eq(pubArgu.swiperBody.activeIndex).addClass('active-nav');
        var tagBar = pubArgu.tagBar;
        var num = tagBar.params.slidesPerView;
        if (activeNav.index() > tagBar.activeIndex + num - 2) {
            var aimIndex = activeNav.index() + 2 - num;
            tagBar.slideTo(aimIndex);
        }
        else if (activeNav.index() < tagBar.activeIndex + 1) {
            var aimIndex = activeNav.index() - 1;
            tagBar.slideTo(aimIndex);
        }
    }
    //刷新tagGroup滑动状态方法
    // function updateNavPosition(curIndex){
    //     $('.swiper-slide.activeTag').removeClass('activeTag');
    //     var activeTag = $('#tagGroup .swiper-slide').eq(curIndex).addClass('activeTag');
    //     if (curIndex > TagGroup.activeIndex) {
    //         if(curIndex > critIndex){
    //             var maxWidth = 0,id;
    //             for(var i=curIndex; i>-1; i--){
    //                 maxWidth += tagWidth[i];
    //                 if(maxWidth > tGWidth){
    //                     id = i + 1;
    //                     TagGroup.slideTo(id);
    //                     break;
    //                 }
    //             }
    //         }
    //     }
    //     else {
    //         TagGroup.slideTo(activeTag.index());
    //     }
    // }
    
    //切换上一个词
    function goPrevWord(){
        var uwid = $('.goPrev').find('p').attr('uwid');
        if(uwid){
            searchText({'uwid':uwid});
        }
    }
    //切换下一个词
    function goNextWord(){
        var uwid = $('.goNext').find('p').attr('uwid');
        if(uwid){
            searchText({'uwid':uwid});
        }
    }

    //swiper补充初始化(释义折叠功能)
    function swiperHideExpInit(){
        if(pubArgu.swiperPages.length){
            $.each(pubArgu.swiperPages, function(){
                var oldfun = this.params.onSetTranslate;
                this.params.onSetTranslate = function(s,val){
                    oldfun(s,val);
                    hideExpScrollTest(s,val);
                };
                this.params.onTransitionEnd = function(s,val){
                    hideExpScrollTest(s,val,true);
                    s.offsetTranslate = 0;
                };
            });
        }
        else {
            var s = pubArgu.swiperMain;
            var oldfun = s.params.onSetTranslate;
            s.params.onSetTranslate = function(s,val){
                oldfun(s,val);
                hideExpScrollTest(s,val,false,true);
            };
            s.params.onTransitionEnd = function(s,val){
                hideExpScrollTest(s,val,true,true);
                s.offsetTranslate = 0;
            };
        }
    }

    //滚动时检测释义折叠
    function hideExpScrollTest(s,val,transitionEnd,isSwiperMain){
        if(folding.className != "show") return;
        var slide = s.slides[0];
        $(slide).find('.hideExp.show').each(function(){
            var line = this.getBoundingClientRect().bottom - pubArgu.tagBarHeight - 80;
            if(line < 0){
                var $this = $(this);
                var height = $this.height();
                var $prev = $this.prev();
                $this.removeClass("show");
                $prev.removeClass("hide");
                folding.className = "";
                s.offsetTranslate = $prev.height() + parseInt($prev.css("margin-top").split("px")[0]) - height;
                if(isSwiperMain){
                    s.params.disOffset = s.offsetTranslate;
                }
                var newtranslate = s.getWrapperTranslate() - s.offsetTranslate;
                var oldbtmLime = s.params.btmLine;
                s.setWrapperTranslate(newtranslate);
                $.commFun.resizeSwiper($this);
                s.setWrapperTranslate(newtranslate);
                s.params.blOffset = s.params.btmLine - oldbtmLime;
                // console.log("animating: "+s.animating + " / " + "transitionEnd: " + transitionEnd + " / " + "isEnd: " + s.isEnd)
                if(s.isEnd){
                    if(s.animating){ //变换过程结束
                        s.params.lockTransitionEnd = 1;
                        s.setWrapperTranslate(s.params.btmLine);
                    }
                    else if(transitionEnd){ //滑动到末尾结束
                        s.params.lockTransitionEnd = 1;
                        setTimeout(function(){
                            s.setWrapperTransition(180);
                            s.setWrapperTranslate(s.params.btmLine);
                        },0);
                    }
                }
            }
        });
    }
    
})(Zepto);